<script lang="ts">
    interface XY {
        x: number
        y: number
    }

    export let source: XY
    export let target: XY
    export let padding: number = 0
    export let opacity: number = 1
    export let color: string = 'black'
    export let headSize: number = 12
    export let controlDistance: number = 0.12
    export let text: string = undefined

    // Middle of line segment between source and target
    let midpoint: XY
    $: midpoint = {
        x: (target.x - source.x) / 2 + source.x,
        y: (target.y - source.y) / 2 + source.y
    }

    // Control point for quadratic bezier curve,
    // some distance perpendicular from midpoint, using controlDistance as relative distance
    let control: XY
    $: control = {
        x: midpoint.x + (target.y - source.y) * controlDistance,
        y: midpoint.y - (target.x - source.x) * controlDistance
    }

    let sourceAngle: number
    $: sourceAngle = Math.atan2(control.y - source.y, control.x - source.x)

    let targetAngle: number
    $: targetAngle = Math.atan2(control.y - target.y, control.x - target.x)

    // Bezier curve begin and end
    $: curve = {
        x1: source.x + Math.cos(sourceAngle) * padding,
        y1: source.y + Math.sin(sourceAngle) * padding,
        x2: target.x + Math.cos(targetAngle) * (padding + headSize),
        y2: target.y + Math.sin(targetAngle) * (padding + headSize)
    }
</script>

<!-- Bezier curve -->
<path d="M {curve.x1} {curve.y1} Q {control.x} {control.y} {curve.x2} {curve.y2}"
      fill="none" stroke={color} stroke-width="2" opacity={opacity}
></path>

<!-- Arrowhead pointing left and rotated to target angle -->
{#if headSize}
    <path d="M {curve.x2} {curve.y2 - headSize/3} l {-headSize} {headSize/3} l {headSize} {headSize/3} z"
          transform="rotate({targetAngle * 180 / Math.PI} {curve.x2} {curve.y2})"
          opacity={opacity} fill={color}
    ></path>
    {#if text}
        <text text-anchor={curve.y1 < curve.y2 ? 'start' : 'end'} dominant-baseline="middle"
        x={control.x} y={control.y} opacity={opacity}>
            {text}
        </text>

    {/if}
{/if}
